%% Semi-automatic IHC thresholding
clear all % Clear previous variables for safety
close all % Close open figures, tables, etc.
clc % Clear the command window
R0=uigetdir('*.*', 'Select the folder with the images');
Folder=dir(R0);
Cell_Folder=struct2cell(Folder);
IMGtotal=length(Cell_Folder)-2;
Out_Tissue_Area=[];
Out_IHC_Area=[];
Out_Name={};
for n=1:IMGtotal
    IMGDisp=['Image #',num2str(n),' of ',num2str(IMGtotal)];
    disp(IMGDisp)
    Imname2=char(Cell_Folder(1,n+2));
    Imname1=char(Cell_Folder(2,n+2));
    Imname=[Imname1,'\',Imname2];
    Out_Name{n}=Imname2;
    disp(Imname2)
    ActualIMG=imread(Imname);
    x=0;
    while x~=1
    figure
    imshow(ActualIMG) % Show the original image
    IG=im2gray(ActualIMG);
    IG2=imadjust(IG);
    figure
    imshow(IG2)
    level=input('Set threshold: ');
    BW=imbinarize(IG2,level); % Generate a black and white image based on the threshold value
    BW2=imcomplement(BW);
    CutIMG=im2double(ActualIMG).*BW2; % Create a mask to control the output of the processing
    figure
    imshow(CutIMG) % Show the original image and the processed image to control the result
    x=input('Is the image okay?(Press 1 to continue, 0 to repeat): ');
    if x==1
        stats = regionprops('table',BW2,'Area'); % Compute the properties of the objects
        Area=stats.Area;
        Tissue_Area=sum(Area);
        y=0;
        while y~=1
            figure
            imshow(IG)
            level2=0.4;
            IG3=im2double(IG).*BW2;
            BW=imbinarize(IG3,level2); % Generate a black and white image based on the threshold value
            BW3=imcomplement(BW);
            BW4=BW3.*BW2;
            CutIMG2=im2double(ActualIMG).*BW4; % Create a mask to control the output of the processing
            figure
            imshow(CutIMG2) % Show the original image and the processed image to control the result
            y=input('Image processed (Press 1 to continue): ');
            if y==1
                stats2 = regionprops('table',BW4,'Area'); % Compute the properties of the objects
                Area2=stats2.Area;
                IHC_Area=sum(Area2);
                Area_Percentage=(IHC_Area/Tissue_Area)*100;
                disp(['The total area of the tissue postitive for IHC is: ',num2str(Area_Percentage),'%'])
            end
        end
    end
    end
end